/*
 * (c) Copyright 1993 by Panagiotis Tsirigotis
 * All rights reserved.  The file named COPYRIGHT specifies the terms 
 * and conditions for redistribution.
 */

#ifndef __TIMER_H
#define __TIMER_H

/*
 * $Id: timer.h,v 1.2 1999/10/18 05:19:57 bbraun Exp $
 */

#include <sys/time.h>
#include "timer_defs.h"

/*
 * Return values
 */
#define TIMER_OK			0
#define TIMER_ERR			(-1)

/*
 * errno values
 */
#define TIMER_ENOMEM				1
#define TIMER_EBADTYPE			2
#define TIMER_EBADSTATE			3
#define TIMER_EBADTIME			4
#define TIMER_ESIGPROBLEM		5
#define TIMER_ECANTINSERT		6
#define TIMER_ENOTAVAILABLE	7

/*
 * flags
 */
#define TIMER_NOFLAGS				0x0
#define TIMER_RETURN_ERROR			0x1
#define TIMER_INC_VAR				0x2
#define TIMER_BLOCK_SAME			0x4
#define TIMER_BLOCK_ALL				0x8
#define TIMER_LONGJMP				0x10


timer_h xtimer_create ( enum timer_types type, int flags, int *errnop ) ;
void xtimer_destroy   ( timer_h handle ) ;
int xtimer_start( timer_h handle, struct itimerval *itvp,
	enum timer_timetypes time_type, struct timer_action *ap );
void xtimer_stop ( timer_h handle ) ;
void xtimer_block ( timer_h handle ) ;
void xtimer_unblock ( timer_h handle ) ;
unsigned xtimer_expirations ( timer_h handle ) ;
void xtimer_block_all ( enum timer_types type ) ;
void xtimer_unblock_all ( enum timer_types type ) ;
char *xtimer_strerr	( timer_h handle );

extern int xtimer_errno ;

#endif	/* __TIMER_H */

